#include "npscan.h"
#include "../npfile.h"
#include <expat.h>

struct NPnmap
{
	bool processing;
	int scanType;
};


/*
#define kNPboxMax 300
struct NPscan
{
	bool run;
	bool process;
	bool readXML;
	int type;
	char nmap[150]; /// Holds system console command to run
	char buf[20000]; /// Holds nmap outputted xml file
	int bufCount;
	char* start; // of buffer
	char* end;   // of buffer
	FILE* xmlFile; // Points to nmap outputted xml file
	char xmlFileName[256];
//	pNPbox box[kNPboxMax];	
};
typedef struct NPscan NPscan;
typedef NPscan* pNPscan;
*/

pNPscan npScanGet(void* dataRef);
pNPscan npScanGet(void* dataRef)
{	
	pData data = (pData) dataRef;
	return &data->io.scan;
}

pNPscanRun npScanRunGet(int index, void* dataRef);
pNPscanRun npScanRunGet(int index, void* dataRef)
{
	pData data = (pData) dataRef;
	pNPscan scan = &data->io.scan; /// @todo npScanGet(void* dataRef)	
	return &scan->scanRun[index];
}


void npElement(void* userData, const char* name, const char **atts)
{
	pData data = (pData) userData; 
	pNPscan scan = npScanGet(userData); 
	int i = 0;
	pNPscanRun scanRun = npScanRunGet(scan->numScans, userData);
	pNPscanHost host = &scanRun->hosts[scan->numScans]; /// [0] null
	int* depthPtr = scan->scanDepth;

	printf("Depth : %d", (*scan->scanDepth));
	// hl
	if( strcmp(name, "nmaprun") == 0 )
	{
	//	npNmaprunAttribs();	
//		scan->runNum++;
		// scanRun = &scan->run[scan->runNum];
		for(i = 0; atts[i]; i+=2) {
			if( strcmp(atts[i], "scanner") == 0 )
			{
				printf("SCANNER\n");
				strcpy(scanRun->scanner, atts[i+1]);
			}

			if( strcmp(atts[i], "args") == 0 )
			{
				printf("ARGS\n");	
				strcpy(scanRun->args, atts[i+1]);
			}

			if( strcmp(atts[i], "start") == 0 )
			{
				printf("START\n");
//				scanRun->start = npstrtoi(atts[i+1]);
				strcpy(scanRun->start, atts[i+1]);
			}

			if( strcmp(atts[i], "startstr") == 0 )
			{
				printf("STARTSTR\n");
				strcpy(scanRun->startstr, atts[i+1]);				
			}
			
			
			if( strcmp(atts[i], "version") == 0 )
			{
				printf("VERSION\n");
				strcpy(scanRun->version, atts[i+1]);				
			}

			if( strcmp(atts[i], "xmloutputversion") == 0 )
			{
				printf("XMLOUTPUTVERSION\n");
				strcpy(scanRun->xmloutputversion, atts[i+1]);				
			}
		}
	}

	printf("23\n");
	// ll

	if( strcmp(name, "scaninfo") == 0 )
	{
		// scanRun->numScanInfo++;
		// scanInfo = &scanRun->scanInfo[scanRun->numScanInfo];
		for(i = 0; atts[i]; i+=2)
		{	
			if( strcmp(atts[i], "type") == 0 )
			{
				printf("TYPE\n");
				// strcpy(scanInfo->type, atts[i+1]);
			}

			if( strcmp(atts[i], "scanflags") == 0 )
			{
				printf("SCANFLAGS\n");
				// strcpy(scanInfo->scanflags, atts[i+1]);
			}

			if( strcmp(atts[i], "protocol") == 0 )
			{
				printf("PROTOCOL\n");
				// strcpy(scanInfo->protocol, atts[i+1]);
			}

			if( strcmp(atts[i], "numservices") == 0 )
			{
				printf("NUMSERVICES\n");
				// scanInfo->numservices = npstrtoi(atts[i+1]);
			}

			if( strcmp(atts[i], "services") == 0 )
			{
				printf("SERVICES\n");
				// strcpy(scanInfo->services, atts[i+1]);	
			}

		}

	}

	if( strcmp(name, "host") == 0 )
	{
		printf("HOST\n");	
		scanRun->numHosts++;
		host = &scanRun->hosts[scanRun->numHosts];
		
		for(i = 0; atts[i]; i+=2) {
			if( strcmp(atts[i], "starttime") == 0 )
			{
				printf("STARTTIME\n");
				strcpy(host->startTime, atts[i+1]);
			}

			if( strcmp(atts[i], "endtime") == 0 )
			{
				printf("ENDTIME\n");
				strcpy(host->endTime, atts[i+1]);
			}

			if( strcmp(atts[i], "comment") == 0 )
			{
				printf("COMMENT\n");
				strcpy(host->comment, atts[i+1]);
			}
		}

		

	}

	if( strcmp(name, "status") == 0 )
	{
		printf("STATUS\n");
		// strcpy(scanInfo->type, atts[i+1]);
	}

	if( strcmp(name, "address") == 0 )
	{
		printf("ADDRESS\n");
		host = &scanRun->hosts[scanRun->numHosts];
		
		for(i = 0; atts[i]; i+=2) {
//			host->address.addr
			if( strcmp( atts[i], "addr" ) == 0 )
			{
				strcpy(host->address.addr, atts[i+1]);
			}

			if( strcmp( atts[i], "addrtype" ) == 0 )
			{
				strcpy(host->address.addrtype, atts[i+1]);
			}

			if( strcmp( atts[i], "vendor" ) == 0 )
			{
				strcpy(host->address.vendor, atts[i+1]);
			}
		}
		/// numAddresses++
		/*
		if(numAddresses > 1)
		{
			
		}

		*/
		// strcpy(scanInfo->scanflags, atts[i+1]);
	}

	if( strcmp(name, "hostnames") == 0 )
	{
		printf("HOSTNAMES\n");
		/// numHostnames++
		/*
		if(numHostnames > 1)
		{
		
		}

		*/

	}

	if( strcmp(name, "smurf") == 0 )
	{
		printf("SMURF\n");
		/// numSmurfs++;
		/*
		if(numSmurfs > 1)
		{

		}
		*/

	}

	if( strcmp(name, "ports") == 0 )
	{
		printf("PORTS\n");
		/// numPorts++;
		/*
		if(numPorts > 1)
		{

		}
		*/
	}

	if( strcmp(name, "os") == 0 )
	{
		printf("OS\n");
		/// numOSes++;
		/*
		if(numOSes > 1)
		{
		
		}
		*/
	}

	if( strcmp(name, "distance") == 0 )
	{
		printf("DISTANCE\n");
		/// numDistances++;
		/*
		if(numDistances > 1)
		{
		
		}
		*/
	}

	/**
	@todo:
	uptime,
	tcpsequence
	ipidsequence
	tcptssequence
	hostscript
	trace
	*/
	// ll
	/*
	if( strcmp(name, "verbose") == 0 )
	{
		
	}

	// ll
	if( strcmp(name, "debugging") == 0 )
	{
		
	}

	// ll
	if( strcmp(name, "target") == 0 )
	{

	}

	// ll
	if( strcmp(name, "taskbegin") == 0 )
	{
		
	}

	// ll
	if( strcmp(name, "taskend") == 0 )
	{
		
	}

	// ll
	if( strcmp(name, "prescript") == 0 )
	{

	}

	// ll
	if( strcmp(name, "postscript") == 0)
	{

	}

	// ll
	if( strcmp(name, "host") == 0)
	{

	}

	// ll
	if( strcmp(name, "output") == 0)
	{

	}

	// ll
	if( strcmp(name, "runstats") == 0)
	{

	}

	// hl
	if( strcmp(name, "scaninfo") == 0 )
	{
		
	}

	*/
	
	*depthPtr += 1;
//	(*scan->scanDepth)++;
	

}

static void XMLCALL
startElement(void *userData, const char *name, const char **atts)
{
	int i;
	int *depthPtr = (int *)userData;
	for(i = 0; i < *depthPtr; i++)
		putchar('\t');

//	printf("%s %s", name, atts[0]);
	printf("%s", name);
	if( strcmp(name, "nmaprun") == 0)
	{
		printf("NMAPRUN start\n");

		for(i = 0; atts[i]; i+=2) {
			if( strcmp(atts[i], "scanner") == 0 )
			{
				printf("SCANNER\n");

			}

			if( strcmp(atts[i], "args") == 0 )
			{
				printf("ARGS\n");	
			}

			if( strcmp(atts[i], "start") == 0 )
			{
				printf("START\n");
			}

			if( strcmp(atts[i], "startstr") == 0 )
			{
				printf("STARTSTR\n");
			}
			
			if( strcmp(atts[i], "version") == 0 )
			{
				printf("VERSION\n");
			}

			if( strcmp(atts[i], "xmloutputversion") == 0 )
			{
				printf("XMLOUTPUTVERSION\n");
			}
		}
	}

	if( strcmp(name, "scaninfo") == 0 )
	{
		printf("SCANINFO start\n");
		for(i = 0; atts[i]; i+=2) {
			if( strcmp(atts[i], "type") == 0 )
			{
				printf("type\n");
			}

			if( strcmp(atts[i], "scanflags") == 0 )
			{
				printf("scanflags\n");	
			}

			if( strcmp(atts[i], "protocol") == 0 )
			{
				printf("protocol\n");
			}

			if( strcmp(atts[i], "numservices") == 0 )
			{
				printf("numservices\n");
			}
			
			if( strcmp(atts[i], "services") == 0 )
			{
				printf("services\n");
			}
		}
	}



	/*
	for(i = 0; atts[i]; i+=2) {
		printf(" %s'%s'", atts[i], atts[i+1]);
	}
	*/

	printf("\n");

	*depthPtr += 1;
}

static void XMLCALL
endElement(void *userData, const char *name)
{
	pData data = (pData) userData;
	int *depthPtr = data->io.scan.scanDepth;
	printf("Closing %s\n", name);
	*depthPtr -= 1;
}

/// @todo "scan states" as antz nodes
void npScanInit(pNPscan scan, void* dataRef)
{
	int i,x = 0;
	pNPscanRun tempScan = NULL;
	scan->bufCount = 0;
	scan->start = &scan->buf[0];
	scan->end   = &scan->buf[scan->bufCount];
	scan->type = 0;
	scan->xmlFile = NULL;
	scan->xmlFileName[0] = '\0';
	scan->process = false; /// @todo add scan->process to NPscan
	scan->run = true;
	scan->readXML = true;
	scan->nmap[0] = '\0'; /// @todo change nmap to scanner
	scan->numScans = 0;
	scan->scanDepth = malloc(sizeof(int));
	(*scan->scanDepth) = 0;

	memset(scan->buf, '\0', sizeof(char) * kNPmapFileBufferMax );

	
	for(i = 0; i < kNPmaxScanRun; i++)
	{
//		scan->scanRun[i].args[0
		tempScan = &scan->scanRun[i];
		tempScan->args[0] = '\0';
		tempScan->scanner[0] = '\0';
		tempScan->start[0] = '\0';
		tempScan->startstr[0] = '\0';
		tempScan->version[0] = '\0';
		tempScan->xmloutputversion[0] = '\0';
		for(x = 0; x < 100; x++)
		{
			tempScan->hosts[x].comment[0] = '\0';
			tempScan->hosts[x].endTime[0] = '\0';
			tempScan->hosts[x].numSeqs = 0;
			tempScan->hosts[x].seqType[0] = 0;
			//tempScan->hosts[x].sequence = NULL;
			tempScan->hosts[x].startTime[0] = '\0';
			tempScan->hosts[x].status[0] = '\0';
			
		}

		tempScan->numHosts = 0;

	}

	
}

void npScanNetworkIP3(char* ip,void* dataRef)
{
	pData data = (pData) dataRef;
	pNPscan scan = &data->io.scan; /// @todo add to NPio
	
	char tempBuffer[5000] = {'\0'};
	static int i = 0;
	int size = 0;
	char filePath[256] = {'\0'};

	XML_Parser parser;
	int depth = 0;
	int done; // for expat

	i++;
	if(scan->run) /// Scan opens the xml file pointer
	{ 
		strcpy(scan->xmlFileName, "output.xml");
		sprintf(scan->nmap, "start /I /MIN nmap -A -oX %s %s", scan->xmlFileName, ip);
//		strcpy(scan->nmap, "start /I /MIN nmap -A -oX output.xml 63.249.110.194");
		system(scan->nmap);
		scan->start = &scan->buf[0];
		scan->run = false; /// when set to false, scan is done
	}

	if(scan->readXML && i > 1000) /// lv, "cycle wise", hitting the file too frequently is inefficient.
	{
		if(scan->xmlFile == NULL)
		{
			strcpy(scan->xmlFileName, "sdk\\vs\\vs2008\\output.xml");
		//	strcpy(scan->xmlFileName, "output.xml");
			nposGetCWD(filePath, dataRef);
			strcat(filePath, scan->xmlFileName);
			scan->xmlFile = npFileOpen(filePath, "r", dataRef);
				
			return;
		}
//kNPmapFileBufferMax
		size = npFileRead(tempBuffer, sizeof(char), 5000 , scan->xmlFile, dataRef);
//		printf("|scan->buf : %s\n", scan->buf);
//		printf("| tempBuffer : %s |\n", tempBuffer);

		strcpy( scan->buf + scan->bufCount , tempBuffer );

		scan->bufCount += size;

		if(size == 0)
		{
			scan->end = strstr(scan->buf, "</nmaprun>");
			if(scan->end != NULL)
			{
				scan->end[10] = '\0';
				scan->readXML = false; /// lv, we're done here
				scan->process = true;
				//scan->buf[0] = scan->buf - scan->bufCount;
//				printf("%s\n", scan->start);
			}
		}
	}

	if(scan->process)
	{
		printf("xml to process : %s\n", scan->buf);
		parser = XML_ParserCreate(NULL);	
//		XML_SetUserData(parser, &depth);
		XML_SetUserData(parser, dataRef);
		XML_SetElementHandler(parser, npElement, endElement);
		XML_Parse(parser, scan->buf, scan->bufCount, done);

		XML_ParserFree(parser);
		scan->process = false;
	}

	return;
}

// npScanCtrl ???
/*
void npScanNetworkIP2(void* dataRef)
{
	pData data = (pData) dataRef;
	pNPscan scan = &data->io.scan; /// @todo add to NPio
	static char newBuf[kNPmapFileBufferMax] = {'\0'};
	static int i = 0;
	int size = 0;
	char filePath[256] = {'\0'};

	i++;
	if(scan->run) /// Scan opens the xml file pointer
	{
		strcpy(scan->nmap, "start /I /MIN nmap -A -oX output.xml 63.249.110.194");
		system(scan->nmap);


		scan->run = false; /// when set to false, scan is done
	}

	/// calculate how frequently to set this to true based on different metrics (type of scan, speed of scan, address range, etc...)
	if(scan->readXML && i > 1000) /// lv, "cycle wise", hitting the file too frequently is inefficient.
	{
		if(scan->xmlFile == NULL)
		{
			strcpy(scan->xmlFileName, "sdk\\vs\\vs2008\\output.xml");
			nposGetCWD(filePath, dataRef);
			strcat(filePath, scan->xmlFileName);
			scan->xmlFile = npFileOpen(filePath, "r", dataRef);
//			scan->start = &scan->buf[0];
			scan->start = &newBuf[0];
			scan->end   = NULL;
			//printf("Could Not open xml file\n");
			return;
		}
		
//		size = npFileRead(&buf[count], 1, kNPfileBlockSize, xmlFile, dataRef);
//		size = npFileRead(scan->buf[			
//		size = npFileRead(scan->buf, 1, 20000, scan->xmlFile, dataRef);
		size = npFileRead(scan->buf, sizeof(char), kNPmapFileBufferMax, scan->xmlFile, dataRef);
		printf("|scan->buf : %s\n", scan->buf);

		strcpy( (newBuf + scan->bufCount), scan->buf );

		scan->bufCount += size;
//		scan->start -= 5;
//		scan->start = &scan->buf - (char*)scan->bufCount; 

		if(size == 0)
		{
			//scan->end = strstr(scan->start, "</nmaprun>");
			scan->end = strstr(newBuf, "</nmaprun>");
			if(scan->end != NULL)
			{
				scan->end[10] = '\0';
				scan->readXML = false; /// lv, we're done here
				scan->process = true;
				//scan->buf[0] = scan->buf - scan->bufCount;
				printf("%s\n", scan->start);
			}
		}
					
		/// if done, set scan->readXML to false
		return;
	}

	if(scan->process) /// lv, we may not want to process the result of the scan immediately
	{
		/// expat parser stuff here
		
		return;
	}

	


	static char buf[20000] = {'\0'};
	char buffer[20000] = {'\0'};
	char nmap[250] = {'\0'};
	static FILE* xmlFile = NULL;
	static bool run = true;

//	strncpy(buffer, buf, 

	if(run)
	{
//		strcpy(nmap, "start /I (nmap -A -oX output.xml 63.249.110.194 && copy output.xml read/output.xml)");
//		strcpy(nmap, "start /I /MIN nmap -A -oX output.xml 63.249.110.194 copy output.xml read/output.xml");
		strcpy(nmap, "start /I /MIN nmap -A -oX output.xml 63.249.110.194");
		/// set output.xml processing var == true
		system(nmap);
		run = false;
	}
	else
	{	
		/// check for (</nmaprun>)
		if(xmlFile == NULL)
		{
			nposGetCWD(filePath, dataRef);		
			strcat(filePath, "sdk\\vs\\vs2008\\output.xml");
		//	strcat(filePath, "output.xml");
			printf("cwd : %s\n", filePath);
			xmlFile = npFileOpen(filePath, "r", dataRef);
			if(xmlFile != NULL)
			{
				printf("xml file opened\n");
			//	size = npFileRead(buf, 1, kNPfileBlockSize, xmlFile, dataRef);
			}
		}

	//	size = npFileRead( buffer, 1, kNPfileBlockSize, file, dataRef );
		if(readMe == true)
		{
			if(xmlFile != NULL)
			{
	//			size = npFileRead(&buf[count], 1, kNPfileBlockSize, xmlFile, dataRef);
				size = npFileRead(buf, 1, 20000, xmlFile, dataRef);
				count += size;

				if( size == 0 )
				{
					/// stop reading if </nmaprun> found
					if( strstr(start, "</nmaprun>") != NULL)
					{
//						end = strstr(buf, "</nmaprun>");
						end = strstr(start, "</nmaprun>");
						end[10] = '\0';
					//	printf("asdf : %s", strstr(buf, "</nmaprun>") );
						//printf("buf : %s\n", buf);
					//	system("pause");
						printf("---------------------------------------------------\n");
						printf("buf : %s\n", start);
						printf("---------------------------------------------------\n");
						readMe = false;
					}
					else
					{
					//	printf("incomplete buf : %s\n", buf);
					}
				}
			}
	}
}
*/

/*
	starts nmap scan, opens [output].xml file
	seeks to end of file and looks for </nmaprun>
	if(</nmaprun>) is found then run expat xml parser and extract
	relevant info
*/
void npScanNetworkIP(void* dataRef)
{
	pData data = (pData) dataRef;
	char nmap[250] = {'\0'};	
//	static buf[9500] = {'\0'};
	static char buf[20000] = {'\0'};
	char filePath[256] = {'\0'};
	static FILE* xmlFile = NULL;
	static bool run = true;
	static bool readMe = true;
	static int size = 0;
	static int count = 0;
	static int i = 0;
	static bool firstRun = true;
	char ch;
	static char* start = &buf[0];
	char* end = NULL;


	if(firstRun == true)
	{
		buf[0] = '\0';
		firstRun = false;
	}

//	NPscan scan;
	/// timestamp xml output (nposTimestamp)
	/// outputs to a temporary directory and when done copies to the "read" directory
	/// "&" executes commands sequentially, this way we "know" that nmap is done outputing
	if(run)
	{
//		strcpy(nmap, "start /I (nmap -A -oX output.xml 63.249.110.194 && copy output.xml read/output.xml)");
//		strcpy(nmap, "start /I /MIN nmap -A -oX output.xml 63.249.110.194 copy output.xml read/output.xml");
		strcpy(nmap, "start /I /MIN nmap -A -oX output.xml 63.249.110.194");
		/// set output.xml processing var == true
		system(nmap);
		run = false;
	}
	else
	{
		/// check for (</nmaprun>)
		if(xmlFile == NULL)
		{
			nposGetCWD(filePath, dataRef);		
			strcat(filePath, "sdk\\vs\\vs2008\\output.xml");
		//	strcat(filePath, "output.xml");
			printf("cwd : %s\n", filePath);
			xmlFile = npFileOpen(filePath, "r", dataRef);
			if(xmlFile != NULL)
			{
				printf("xml file opened\n");
			//	size = npFileRead(buf, 1, kNPfileBlockSize, xmlFile, dataRef);
			}
		}

	//	size = npFileRead( buffer, 1, kNPfileBlockSize, file, dataRef );
		if(readMe == true)
		{
			if(xmlFile != NULL)
			{
	//			size = npFileRead(&buf[count], 1, kNPfileBlockSize, xmlFile, dataRef);
				size = npFileRead(buf, 1, 20000, xmlFile, dataRef);
				count += size;

				if( size == 0 )
				{
					/// stop reading if </nmaprun> found
					if( strstr(start, "</nmaprun>") != NULL)
					{
//						end = strstr(buf, "</nmaprun>");
						end = strstr(start, "</nmaprun>");
						end[10] = '\0';
					//	printf("asdf : %s", strstr(buf, "</nmaprun>") );
						//printf("buf : %s\n", buf);
					//	system("pause");
						printf("---------------------------------------------------\n");
						printf("buf : %s\n", start);
						printf("---------------------------------------------------\n");
						readMe = false;
					}
					else
					{
					//	printf("incomplete buf : %s\n", buf);
					}
				}
			}
		}
		/*
		if(size > 0)
			printf("buf : %s\n", buf); 
		*/
/*

		if(size == 0)
		{
			printf("size is 0\n");
		}
		*/
	//	fread(
		/*
		if(xmlFile != NULL)
		{
			ch = fgetc(xmlFile);
			if(ch == EOF)
			{
				printf("Reached End of File\n");
				printf("count is %d\n", i);
//				printf("buf : %s\n", buf);
			//	system("pause");
			}
			else
			{
	//			strcat(buf, ch);
				buf[i] = ch;
				i++;
//				printf("%c", ch);	
			}
		}
		*/
	}
	

//	system("pause");

	return;
}

void npscanTest(void* dataRef)
{
	XML_ParserCreate(NULL);
	return;
}